/*
Main js-file. Moves the joysticks, handle video and update info.
Made by Torkil Eide Solstad
*/

var inputMode = "joy"; //"joy" or "touch"

var depth_touch_on = false;
var heading_touch_on = false;
var DP_touch_on = false;

var path_mode = false;

//distace the joysticks can move
var joystickDis_right = (235 / 2 - 47 / 2);
var joystickDis_left = (235 / 2 - 47 / 2);

//top-panel hide
var hide_panels=true;

//hide_show info
var hide_show_i = 3;

//To get the topBar to dissapear after 15 sec.
var topBarTimeOut;

var radius_left_joystick = 160;

//defining offset
var offset_right_x=0;
var offset_right_y=0;
var offset_left_x=0;
var offset_left_y=0;

var depth=0;
var heading=0;
var delta_depth=0;
var delta_heading=0;

var scaling = 0.2;

function moveJoystickOnScrean(value,dir){
	switch(dir){
		case "yaw":
			offset_left_x = Number(value*joystickDis_left);
			//if((offset_right_x*offset_right_x+offset_right_y*offset_right_y) > joystickDis_right*joystickDis_right ){
				//Placeholder to make the right joystick move in a sircle
			//}
			$( "#leftJoyStick_circle_div" ).offset({ left: middle_left_x + offset_left_x, top: middle_left_y + offset_left_y});

			sendcommand(-0.8*value*scaling,dir);

			break;
		case "surge":
			offset_left_y=Number(-value*joystickDis_left);
			//if((offset_right_x*offset_right_x+offset_right_y*offset_right_y) > joystickDis_right*joystickDis_right ){
				//Placeholder to make the right joystick move in a sircle
			//}
			$( "#leftJoyStick_circle_div" ).offset({ left: middle_left_x + offset_left_x, top: middle_left_y + offset_left_y});

			sendcommand(value*scaling,dir);

			break;
		case "heave":
			offset_right_y=Number(-value*joystickDis_right);
			//offset_left_x=Number( - radius_left_joystick + Math.sqrt( radius_left_joystick*radius_left_joystick - offset_left_y*offset_left_y))
			$( "#rightJoyStick_circle_div" ).offset({ left: middle_right_x + offset_right_x, top: middle_right_y + offset_right_y});
			if(controlMode=="AutoD" || controlMode=="AutoH"){
				sendcommand(value*scaling,"surge");
			}
			else {
				sendcommand(value*scaling,dir);
			}
			break;
		case "sway":
			offset_right_x=Number(value*joystickDis_right);
			$( "#rightJoyStick_circle_div" ).offset({ left: middle_right_x + offset_right_x, top: middle_right_y + offset_right_y});

			sendcommand(-value*scaling,dir);

			break;
		default:
			return;
		}
}

//hide/show topbar
function hide_show_topbar(){
	if(hide_panels){
		$("#top-bar").show("scale");
		moveheading("down");
		hide_panels=false;
		topBarTimeOut=setTimeout(function() {
			$("#top-bar").hide("scale");
			moveheading("up");
			hide_panels = true;
		}, 15000 );
	}
	else{
		$("#top-bar").hide("scale");
		moveheading("up");
		hide_panels=true;
		clearTimeout(topBarTimeOut);
	}
}

//move heading down
function moveheading(direction){
	switch (direction) {
		case "up":
			setTimeout(function() {
				$(".Heading_info").css("top", 20);
			}, 300);
			break;
		case "down":
			$(".Heading_info").css("top",  40 + 20);
			break;
		default:
			break;
	}

}

//Hide/Show info
	//1 only joystics
	//2 with depth and Heading
	//3 with battery and motionIndicator

function hide_show_info(){
	if(hide_show_i==1){
		$("#Depth_info").show();
		$("#Heading_info").show();
		hide_show_i=2;
	}
	else if(hide_show_i==2){
		$("#batteryinfo").show();
		$("#warning").show();
		hide_show_i=3;
	}
	else if(hide_show_i==3){
		$("#batteryinfo").hide();
		$("#warning").hide();
		$("#Depth_info").hide();
		$("#Heading_info").hide();
		hide_show_i=1;
	}
}

function changeInputMode(mode){
	switch (mode) {
		case "Touch":
			inputMode="touch";
			document.getElementById("controlMode_Touch").style.backgroundColor="rgba(0, 255, 0, 0.5)";
			document.getElementById("controlMode_Joy").style.backgroundColor="rgba(255, 0, 0, 0.5)";
			break;
		case "Joy":
			inputMode="joy";
			document.getElementById("controlMode_Touch").style.backgroundColor="rgba(255, 0, 0, 0.5)";
			document.getElementById("controlMode_Joy").style.backgroundColor="rgba(0, 255, 0, 0.5)";
			break;
		default:
			break;
	}
}

function displayDepth(depth_in){
	delta_depth=depth_in;
	if(depth_touch_on==false){
		depth=depth_in;
		document.getElementById("depth_scale_div").style.backgroundPosition = "0px " + (40 - depth*80) + "px";
	}
}

function displayCurrentDepth(){
	document.getElementById("depth_scale_div").style.backgroundPosition = "0px " + (40 - depth*80) + "px";
	document.getElementById("depth_indicator").style.top = (107);
}

function moveDepth(wanted_depth){
	document.getElementById("depth_scale_div").style.backgroundPosition = "0px " + (40 - wanted_depth - depth*80) + "px";
	document.getElementById("depth_indicator").style.top = (107 - wanted_depth - (depth-delta_depth)*80);
}

function displayDesiredDepth(desired_depth){
	if(depth_touch_on==false){
		document.getElementById("aDepth_indicator").style.top = (107 - (depth-desired_depth)*80);
	}
}

function displayHeading(heading_in){
	delta_heading=heading_in;
	if(heading_touch_on==false){
		heading=heading_in;
		document.getElementById("heading_scale_div").style.backgroundPosition =  (-1600 - heading*11.1) + "px 0px";
	}
}

function displayCurrentHeading(){
	document.getElementById("heading_scale_div").style.backgroundPosition =  (-1600 - heading*11.1) + "px 0px";
	document.getElementById("heading_indicator").style.left = (175);
}

function moveHeading(wanted_heading){
	document.getElementById("heading_scale_div").style.backgroundPosition = (-1600 - wanted_heading*2 - heading*11.1) + "px 0px";
	document.getElementById("heading_indicator").style.left = (175 - wanted_heading*2 - (heading-delta_heading)*11.1);
	if(controlMode=="AutoH" || controlMode=="DP"){
		setAutoHeading(wanted_heading);
	}
	else if(controlMode=="AutoD"){
		sendcommand(-((heading-delta_heading)+wanted_heading*2/11.1)/50,"yaw");
	}
}

function displayDesiredHeading(desired_heading){
	if(heading_touch_on==false){
		if(desired_heading>180){
			desired_heading=desired_heading-360;
		}
		document.getElementById("aHeading_indicator").style.left = (175 - (heading-desired_heading)*11.1);
	}
}

function displayXY(){

	if(DP_touch_on==false){
		xValueDP = (xPos - desX_in)*150;
		if(xValueDP>155){
			xValueDP=155;
		}
		if(xValueDP<-155){
			xValueDP=-155;
		}
		yValueDP = (desY_in - yPos)*150;
		if(yValueDP>155){
			yValueDP=155;
		}
		if(yValueDP<-155){
			yValueDP=-155;
		}
		$( "#DP-ref_div" ).offset({ left: middle_right_DP_x + yValueDP, top: middle_right_DP_y + xValueDP});
	}
	else if (DP_touch_on){
		xValue = - (- xPos + delta_xPos)*150;
		yValue = - (- delta_yPos + yPos)*150;
		$( "#DP-pos_div" ).offset({ left: middle_right_DP_x - yValue, top: middle_right_DP_y - xValue});
	}
}

function displayBattery(battery){
	console.log("battery = " + battery);
	var betteryImgElement = document.getElementById('batteryimg');
	battery_img_number = Math.floor(battery / 11.2);
	var adress = "Pictures/battery/battery" + battery_img_number + "-8.png";
	betteryImgElement.setAttribute("src", adress);
}

window.onload = function(){
	handleVideo();
}
