/*
 Handle touch events
 Made by Torkil Eide Solstad
 */

var left_joystick_touch_Y = 0;
var left_joystick_touch_X = 0;
var right_joystick_touch_Y = 0;
var right_joystick_touch_X = 0;
var depth_touch = 0;
var heading_touch = 0;
var video_touch_x = 0;
var video_touch_y = 0;

var DP_touch_X = 0;
var DP_touch_Y = 0;

var delta_xPos = 0;
var delta_yPos = 0;
var delta_xPriv = 0;
var delta_yPriv = 0;

var xValueDP = 0;
var yValueDP = 0;

var init_pan_x = 1;
var init_pan_y = 1;

function setup_touch_event() {

    //depth bar
    var el_depth = document.getElementById("depth_scale_div");
    el_depth.addEventListener("touchstart", handleStart_depth, false);
    el_depth.addEventListener("touchend", handleEnd_depth, false);
    el_depth.addEventListener("touchleave", handleEnd_depth, false);
    el_depth.addEventListener("touchmove", handleMove_depth, false);

    var el_heading = document.getElementById("heading_scale_div");
    el_heading.addEventListener("touchstart", handleStart_heading, false);
    el_heading.addEventListener("touchend", handleEnd_heading, false);
    el_heading.addEventListener("touchleave", handleEnd_heading, false);
    el_heading.addEventListener("touchmove", handleMove_heading, false);

    //video
    var el_video = document.getElementById("video_container");
    el_video.addEventListener("touchstart", handleStart_video, false);
    el_video.addEventListener("touchend", handleEnd_video, false);
    el_video.addEventListener("touchleave", handleEnd_video, false);
    el_video.addEventListener("touchmove", handleMove_video, false);

    //left
    var el_l = document.getElementById("leftJoyStick_circle_div");
    el_l.addEventListener("touchstart", handleStart_l, false);
    el_l.addEventListener("touchend", handleEnd_l, false);
    el_l.addEventListener("touchleave", handleEnd_l, false);
    el_l.addEventListener("touchmove", handleMove_l, false);

    //right
    var el_r = document.getElementById("rightJoyStick_circle_div");
    el_r.addEventListener("touchstart", handleStart_r, false);
    el_r.addEventListener("touchend", handleEnd_r, false);
    el_r.addEventListener("touchleave", handleEnd_r, false);
    el_r.addEventListener("touchmove", handleMove_r, false);

    var el_DP = document.getElementById("DP-ref_div");
    el_DP.addEventListener("touchstart", handleStart_DP, false);
    el_DP.addEventListener("touchend", handleEnd_DP, false);
    el_DP.addEventListener("touchleave", handleEnd_DP, false);
    el_DP.addEventListener("touchmove", handleMove_DP, false);

    //var el_DP = document.getElementById("DP-pos_div");
    //el_DP.addEventListener("touchstart", handleStart_DP, false);
    //el_DP.addEventListener("touchend", handleEnd_DP, false);
    //el_DP.addEventListener("touchleave", handleEnd_DP, false);
    //el_DP.addEventListener("touchmove", handleMove_DP, false);

    //topbar_button
//	var el_topbar = document.getElementById("hide_show_topbar");
//	el_topbar.onclick=function(event){
//    hide_show_topbar();
//		event.preventDefault();
//	};

    //control modes
    document.getElementById("controlMode_Touch").onclick = function () {
        changeInputMode("Touch");
    }
    document.getElementById("controlMode_Joy").onclick = function () {
        changeInputMode("Joy");
    }
    document.getElementById("controlMode_Motion").onclick = function () {
        changeControlMode("Motion");
    }
    document.getElementById("controlMode_Direct").onclick = function () {
        changeControlMode("Direct");
    }
    document.getElementById("controlMode_AutoD").onclick = function () {
        changeControlMode("AutoD");
    }
    document.getElementById("controlMode_AutoH").onclick = function () {
        changeControlMode("AutoH");
    }
    document.getElementById("controlMode_Oculus").onclick = function () {
        changeControlMode("Oculus");
    }
    /*document.getElementById("controlMode_DP").onclick=function(){
     changeControlMode("DP");
     }*/
    document.getElementById("controlMode_Oculus").onclick = function () {
        changeControlMode("OculusDP");
    }
    document.getElementById("controlMode_Path").onclick = function () {
        changeControlMode("Pathfollowing");
    }
    document.getElementById("Camera_info").onclick = function () {
        hide_show_cameraInfo();
    }


    //i-button
    //var el_info = document.getElementById("hide_show_info");
    //el_info.onclick=function(event){
    //	hide_show_info();
    //	event.preventDefault();
    //};
    //console.log("initialized touch");
}

//Depth
function handleStart_depth(evt) {
    evt.preventDefault();
    document.getElementById("aDepth_indicator").style.top = (107);
    depth_touch_on = true;
    var touches = evt.changedTouches;
    depth_touch = touches[0].pageY;
}

function handleEnd_depth(evt) {
    evt.preventDefault();
    depth_touch_on = false;
    displayCurrentDepth();
    var touches = evt.changedTouches;
    setAutoDepth(depth_touch - touches[0].pageY);
}

function handleMove_depth(evt) {
    evt.preventDefault();
    var touches = evt.changedTouches;
    moveDepth(depth_touch - touches[0].pageY);
    setAutoDepth(depth_touch - touches[0].pageY);
}

//Heading
function handleStart_heading(evt) {
    evt.preventDefault();
    document.getElementById("aHeading_indicator").style.left = (175);
    heading_touch_on = true;
    var touches = evt.changedTouches;
    heading_touch = touches[0].pageX;
}

function handleEnd_heading(evt) {
    evt.preventDefault();
    heading_touch_on = false;
    displayCurrentHeading();
    var touches = evt.changedTouches;
    if (controlMode == "AutoH" || controlMode == "DP") {
        setAutoHeading(heading_touch - touches[0].pageX);
    }
    else if (controlMode == "AutoD") {
        sendcommand(0, "yaw");
    }
}

function handleMove_heading(evt) {
    evt.preventDefault();
    var touches = evt.changedTouches;
    moveHeading(heading_touch - touches[0].pageX);
}

//Camera_paning
function handleStart_video(evt) {
    evt.preventDefault();
    var touches = evt.changedTouches;
    video_touch_x = touches[0].pageX;
    video_touch_y = touches[0].pageY;
    init_pan_x = Number(document.getElementById("camera_offsetx").value);
    init_pan_y = Number(document.getElementById("camera_offsety").value);
}

function handleEnd_video(evt) {
    evt.preventDefault();
}

function handleMove_video(evt) {
    evt.preventDefault();
    var touches = evt.changedTouches;
    var verdi = 0;
    if (zoom_button == 2) {
        document.getElementById("camera_offsetx").value = -init_pan_x + 0.001 * (video_touch_x - touches[0].pageX);
        document.getElementById("camera_offsety").value = -init_pan_y + 0.001 * (video_touch_y - touches[0].pageY);
        sendCameraParameters();
    }
    else if (zoom_button == 4) {
        document.getElementById("camera_offsetx").value = -init_pan_x + 0.001 * (video_touch_x - touches[0].pageX);
        document.getElementById("camera_offsety").value = -init_pan_y + 0.001 * (video_touch_y - touches[0].pageY);
        sendCameraParameters();
    }
}

//left_joystick
function handleStart_l(evt) {
    evt.preventDefault();
    var touches = evt.changedTouches;
    left_joystick_touch_Y = touches[0].pageY;
    left_joystick_touch_X = touches[0].pageX;
}

function handleEnd_l(evt) {
    changeControlMode("OculusDP");
    evt.preventDefault();
    if (inputMode == "touch") {
        moveJoystickOnScrean(0, "surge");
        moveJoystickOnScrean(0, "yaw")
    }
}

function handleMove_l(evt) {
    evt.preventDefault();
    var touches = evt.changedTouches;
    var valueY = (left_joystick_touch_Y - touches[0].pageY) / joystickDis_left;

    if (valueY > 1) {
        valueY = 1;
    }
    else if (valueY < -1) {
        valueY = -1;
    }


    var valueX = (left_joystick_touch_X - touches[0].pageX) / joystickDis_left;

    if (valueX > 1) {
        valueX = 1;
    }
    else if (valueX < -1) {
        valueX = -1;
    }

    if (inputMode == "touch") {
        moveJoystickOnScrean(valueY, "surge");
        moveJoystickOnScrean(-valueX, "yaw");
    }
}

//right joystick
function handleStart_r(evt) {
    evt.preventDefault();

    var touches = evt.changedTouches;
    right_joystick_touch_Y = touches[0].pageY;
    right_joystick_touch_X = touches[0].pageX;

}

function handleEnd_r(evt) {
    evt.preventDefault();
    //console.log("handle End");
    if (inputMode == "touch") {
        moveJoystickOnScrean(0, "heave");
        moveJoystickOnScrean(0, "sway");
    }
}

function handleMove_r(evt) {
    evt.preventDefault();
    var touches = evt.changedTouches;
    var valueY = (right_joystick_touch_Y - touches[0].pageY) / joystickDis_right;

    if (valueY > 1) {
        valueY = 1;
    }
    else if (valueY < -1) {
        valueY = -1;
    }
    var valueX = (right_joystick_touch_X - touches[0].pageX) / joystickDis_right;


    if (valueX > 1) {
        valueX = 1;
    }
    else if (valueX < -1) {
        valueX = -1;
    }

    if (inputMode == "touch") {
        moveJoystickOnScrean(-valueX, "sway");
        moveJoystickOnScrean(valueY, "heave");
    }
}

//DP-control
function handleStart_DP(evt) {
    evt.preventDefault();
    DP_touch_on = true;

    var touches = evt.changedTouches;
    DP_touch_Y = touches[0].pageY;
    DP_touch_X = touches[0].pageX;

    delta_xPriv = xValueDP;
    delta_yPriv = yValueDP;
    delta_xPos = xPos;
    delta_yPos = yPos;
}

function handleEnd_DP(evt) {
    evt.preventDefault();
    $("#DP-pos_div").offset({left: middle_right_DP_x, top: middle_right_DP_y});
    DP_touch_on = false;
}

function handleMove_DP(evt) {
    evt.preventDefault();
    var touches = evt.changedTouches;
    yValueDP = +delta_yPriv + (DP_touch_Y - touches[0].pageY);
    if (yValueDP > 150) {
        yValueDP = 150;
    }
    else if (yValueDP < -150) {
        yValueDP = -150;
    }

    xValueDP = +delta_xPriv + (DP_touch_X - touches[0].pageX);
    if (xValueDP > 150) {
        xValueDP = 150;
    }
    else if (xValueDP < -150) {
        xValueDP = -150;
    }

    $("#DP-ref_div").offset({left: middle_right_DP_x - xValueDP, top: middle_right_DP_y - yValueDP});

    setDPinput((yValueDP) / 150, (-xValueDP) / 150);
}

//RUN on load
setup_touch_event();
