var gl = null,
    canvas = null,
    glProgram = null,
    glProgram2 = null,
    fragmentShader = null,
    fragmentShader2 = null,
    vertexShader = null;

var i = 0;

var vertexPositionAttribute = null,
    verticeBuffer = null,
    verticeBufferTemp = null;

var vMatrix = mat4.create(),
    pMatrix = mat4.create();

var vertices = null;
var verticesTemp = null;

// Locked in path
var S0 = 0.0;
var Nl = 0;
var ds = 0.1;
var kappa = 0.0;
var init_x_pos = 0.0;
var init_y_pos = 0.0;
var init_psi   = 0.0;

var kappa_last = 0.0;

var pathCurrentDesiredHeading,
    pathCurrentDesiredX,
    pathCurrentDesiredY;

var joy_x = 0.0;
var joy_y = 0.0;

var zPos = 0.0;
var psiPos = 0.0;

var path_depth = 1.0;


$(document).ready(function () {
    setupGL();
});

function setKappa(val)
{
    kappa = val;

    vertices = SF(S0, [pathCurrentDesiredX, pathCurrentDesiredY], pathCurrentDesiredHeading, ds, Nl, kappa, autoDepth + path_depth);
    //animLoop();
}

function setNl(val)
{
    //Nl = val;

    vertices = SF(S0, [pathCurrentDesiredX, pathCurrentDesiredY], pathCurrentDesiredHeading, ds, Nl, kappa, autoDepth + path_depth);
    //animLoop();
}

function setKappaTemp(val)
{
    kappa = val;

    vertices = SF(S0, [pathCurrentDesiredX, pathCurrentDesiredY], pathCurrentDesiredHeading, ds, Nl, kappa, autoDepth + path_depth);
    //animLoop();
}

function setNlTemp(val)
{
    //Nl = val;

    vertices = SF(S0, [pathCurrentDesiredX, pathCurrentDesiredY], pathCurrentDesiredHeading, ds, Nl, kappa, autoDepth + path_depth);
    //animLoop();
}

function setupGL()
{
    canvas = document.getElementById("path-overlay");

    canvas.width = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
    canvas.height = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);

    try {
        gl = canvas.getContext("webgl") || canvas.getContext("experimental-webgl");
    } catch (e) {}

    if (gl) {
        vertices = SF(S0, [init_x_pos, init_y_pos], init_psi, ds, Nl, kappa, zPos + path_depth);
        // verticesTemp = SF(S0, [init_x_pos_set, init_y_pos_set], init_psi_set, ds, Nl_set, kappa_set, zPos + 4.9);

        initShaders();
        setupBuffers();
        getMatrixUniforms();
        animLoop();
    } else {
        alert("No WebGL!");
    }
}

function animLoop() {
    setupWebGL();
    setMatrixUniforms();
    drawScene();
    requestAnimationFrame(animLoop);
};

function initShaders() {
    var vertCode = 'attribute highp vec3 aVertexPosition;' +
        '' +
        'uniform mat4 uMVMatrix;' +
        'uniform mat4 uPMatrix;' +
        '' +
        'void main(void) {' +
        '    gl_Position = uPMatrix * uMVMatrix * vec4(aVertexPosition, 1.0);' +
        '}';
    var fragCode =
        'void main(void) {' +
        '   gl_FragColor = vec4(0.7, 0.4, 0.1, 0.2);' +
        '}';

    // var fragCode2 =
    //     'void main(void) {' +
    //     '   gl_FragColor = vec4(0.8, 0.3, 0.1, 0.1);' +
    //     '}';


    vertexShader = gl.createShader(gl.VERTEX_SHADER);
    gl.shaderSource(vertexShader, vertCode);
    gl.compileShader(vertexShader);

    fragmentShader = gl.createShader(gl.FRAGMENT_SHADER);
    gl.shaderSource(fragmentShader, fragCode);
    gl.compileShader(fragmentShader);

    // fragmentShader2 = gl.createShader(gl.FRAGMENT_SHADER);
    // gl.shaderSource(fragmentShader2, fragCode2);
    // gl.compileShader(fragmentShader2);

    glProgram = gl.createProgram();
    gl.attachShader(glProgram, vertexShader);
    gl.attachShader(glProgram, fragmentShader);
    gl.linkProgram(glProgram);
    gl.useProgram(glProgram);

    // glProgram2 = gl.createProgram();
    // gl.attachShader(glProgram2, vertexShader);
    // gl.attachShader(glProgram2, fragmentShader2);
    // gl.linkProgram(glProgram2);
    // gl.useProgram(glProgram2);
}

function setupBuffers() {
    gl.useProgram(glProgram);
    verticeBuffer = gl.createBuffer();
    gl.bindBuffer(gl.ARRAY_BUFFER, verticeBuffer);
    gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(vertices), gl.DYNAMIC_DRAW);

    // gl.useProgram(glProgram2);
    // verticeBufferTemp = gl.createBuffer();
    // gl.bindBuffer(gl.ARRAY_BUFFER, verticeBufferTemp);
    // gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(verticesTemp), gl.DYNAMIC_DRAW);
}

function setupWebGL() {
    gl.useProgram(glProgram);
    gl.viewport(0, 0, canvas.width, canvas.height); //-(canvas.height/2)
    gl.clearColor(0.0, 0.0, 0.0, 0.0);
    gl.enable(gl.DEPTH_TEST);
    gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);

    //gl.useProgram(glProgram2);
    //gl.viewport(0, 0, canvas.width, canvas.height); //-(canvas.height/2)
    //gl.clearColor(0.0, 0.0, 0.0, 0.0);
    //gl.enable(gl.DEPTH_TEST);
    //gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);

    mat4.perspective(pMatrix, 90, canvas.width / canvas.height, 0.25, 10.0);
    mat4.invert(pMatrix, pMatrix);
    mat4.identity(vMatrix);
    mat4.rotate(vMatrix, vMatrix, 90*(Math.PI/180), [1.0, 0.0, 0.0]);
    mat4.rotate(vMatrix, vMatrix, heading*(Math.PI/180), [0.0, 0.0, 1.0]);
    mat4.rotate(vMatrix, vMatrix, 0*(Math.PI/180), [0.0, 1.0, 0.0]);
    mat4.invert(vMatrix, vMatrix);
    mat4.translate(vMatrix, vMatrix, [-yPos, -xPos-0.5, 0.0]);
}

function drawScene() {
    /* Update the path to draw */
    gl.useProgram(glProgram);
    gl.bindBuffer(gl.ARRAY_BUFFER, verticeBuffer);
    gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(vertices), gl.DYNAMIC_DRAW);
    vertexPositionAttribute = gl.getAttribLocation(glProgram, "aVertexPosition");
    gl.enableVertexAttribArray(vertexPositionAttribute);
    gl.bindBuffer(gl.ARRAY_BUFFER, verticeBuffer);
    gl.vertexAttribPointer(vertexPositionAttribute, 3, gl.FLOAT, false, 0, 0);
    gl.drawArrays(gl.TRIANGLE_STRIP, 0, vertices.length/3);

    // gl.useProgram(glProgram2);
    // gl.bindBuffer(gl.ARRAY_BUFFER, verticeBufferTemp);
    // gl.bufferData(gl.ARRAY_BUFFER, new Float32Array(verticesTemp), gl.DYNAMIC_DRAW);
    // vertexPositionAttribute = gl.getAttribLocation(glProgram, "aVertexPosition");
    // gl.enableVertexAttribArray(vertexPositionAttribute);
    // gl.bindBuffer(gl.ARRAY_BUFFER, verticeBufferTemp);
    // gl.vertexAttribPointer(vertexPositionAttribute, 3, gl.FLOAT, false, 0, 0);
    // gl.drawArrays(gl.TRIANGLE_STRIP, 0, vertices.length/3);
}


function getMatrixUniforms() {
    glProgram.pMatrixUniform = gl.getUniformLocation(glProgram, "uPMatrix");
    glProgram.mvMatrixUniform = gl.getUniformLocation(glProgram, "uMVMatrix");

    // glProgram2.pMatrixUniform = gl.getUniformLocation(glProgram2, "uPMatrix");
    // glProgram2.mvMatrixUniform = gl.getUniformLocation(glProgram2, "uMVMatrix");
}

function setMatrixUniforms() {
    gl.useProgram(glProgram);
    gl.uniformMatrix4fv(glProgram.pMatrixUniform, false, pMatrix);
    gl.uniformMatrix4fv(glProgram.mvMatrixUniform, false, vMatrix);

    // gl.useProgram(glProgram2);
    // gl.uniformMatrix4fv(glProgram2.pMatrixUniform, false, pMatrix);
    // gl.uniformMatrix4fv(glProgram2.mvMatrixUniform, false, vMatrix);
}